//malloc simple implementation for Raisonance compiler (for this project only)

#include <stm8l15x.h>
#include "stm8l15x_conf.h"

#ifdef _RAISONANCE_

static unsigned char data GlobalHeap[0x530];
unsigned int GlobalHeapSize;


//allocates from GlobalHeap
void * Rmalloc(unsigned int size)
{
  unsigned int i;
  static unsigned char First = 1;

  if (First)
  {
    First = 0;
    GlobalHeap[0]=0;
    GlobalHeapSize = 0x7FF - 0x80 - (unsigned int)&GlobalHeap; //top RAM - stack size - heap start
    *((unsigned int *)&GlobalHeap[1]) = GlobalHeapSize-3;
  }

  i=0;
  while(i<GlobalHeapSize)
  {
    if((GlobalHeap[i] | GlobalHeap[i+1] | GlobalHeap[i+2])==0)
    {

      GlobalHeap[i]=0xFF;
      *((unsigned int *)&GlobalHeap[i+1]) = size + 2;
      return(&GlobalHeap[i+3]);
    }

    if ((GlobalHeap[i]==0) && (*((unsigned int *)&GlobalHeap[i+1]) > (size+3)))
    {

      GlobalHeap[i+size+3]=0x00; //unallocated
      *((unsigned int *)&GlobalHeap[i+1+size+3])= *((unsigned int *)&GlobalHeap[i+1]) - (size+3);

      GlobalHeap[i]=0xFF;
      *((unsigned int *)&GlobalHeap[i+1]) = size;

      return(&GlobalHeap[i+3]);
    }

    i += *((unsigned int*)&GlobalHeap[i+1]) + 3;
  }
  return(0);
}

//unallocates from GlobalHeap
void Rfree(void * pointer)
{
  unsigned int i,j,k,m3;
  unsigned char * Ppointer = pointer;

  Ppointer -=3;
  *Ppointer = 0;


  //merge all free spaces
  i=0;
  while(i < GlobalHeapSize)
  {
    k  = 0;
    m3 = 0;
    j = i;
    while((GlobalHeap[i] == 0) && (i < GlobalHeapSize))
    {
      k  += *((unsigned int *)&GlobalHeap[i+1]);
      i  += *((unsigned int *)&GlobalHeap[i+1]) + 3;
      *((unsigned int *)&GlobalHeap[j+1]) = k + m3;
      m3 += 3;
    }
    i = j + *((unsigned int*)&GlobalHeap[j+1]) + 3;
  }
}

#endif