/**
  ******************************************************************************
  * @file stm8l15x_conf.h
  * @brief This file is used to configure the Library.
  * It is given as a TEMPLATE. Copy this file in your project main directory
  * and change it according to your needs.
  * @author STMicroelectronics - MCD Application Team
  * @version V0.0.2
  * @date 02/20/2009
  ******************************************************************************
  *
  */

// Define to prevent recursive inclusion -------------------------------------
#ifndef __STM8L15x_CONF_H
#define __STM8L15x_CONF_H

// Includes ------------------------------------------------------------------
#include "stm8l15x.h"

// Exported types ------------------------------------------------------------
// Exported constants --------------------------------------------------------

// Uncomment the line below to use the cosmic section 
#if defined(__CSMC__)
// #define USE_COSMIC_SECTIONS  (1)  
#endif

/* Uncomment the line below to compile the library in DEBUG mode.
   This will expanse the "assert" macro in the firmware library code
   (see "Exported macro" section below) */
// #define DEBUG (1)

// Uncomment the line below to use the full assert mode 
// #define FULL_ASSERT (1)

// Comment the line below to disable the specific peripheral inclusion 

 // ADC *********************************************************************
// #define _ADC (1)

 // BEEP ********************************************************************
// #define _BEEP (1)

 // Configuration Registers *************************************************
// #define _CFG (1)

 // CLOCK CONTROLLER ********************************************************
#define _CLK (1)

 // COMPARATOR **************************************************************
// #define _COMP (1)

 // DAC *********************************************************************
// #define _DAC (1)

 // DMA *********************************************************************
// #define _DMA (1)
// #define _DMA_Channel0 (1)
// #define _DMA_Channel1 (1)
// #define _DMA_Channel2 (1)
// #define _DMA_Channel3 (1)

 // EXTERNAL INTERRUPTS *****************************************************
// #define _EXTI (1)

 // FLASH/DATA EEPROM *******************************************************
// #define _FLASH (1)

 // GENERAL PURPOSE IOs *****************************************************
#define _GPIOA (1)
#define _GPIOB (1)
#define _GPIOC (1)
#define _GPIOD (1)
#define _GPIOE (1)
#define _GPIOF (1)

 // AFIO ********************************************************************
// #define _FLASH (1)

 // INTERRUPT CONTROLLER ****************************************************
// #define _ITC (1)

 // I2C *********************************************************************
// #define _I2C (1)

 // INDEPENDANT WDG *********************************************************
// #define _IWDG (1)

 // LCD  CONTROLLER**********************************************************
// #define _LCD (1)

 // OPTION BYTES ************************************************************
// #define _OPT (1)

 // POWER *******************************************************************
// #define _PWR (1)

 // ROUTING INTERFACE *******************************************************
// #define _RI (1)

 // RESET CONTROLLER ********************************************************
// #define _RST (1)

 // RTC *********************************************************************
// #define _RTC (1)

 // SPI *********************************************************************
#define _SPI (1)

 // TIMERs ******************************************************************
// #define _TIM1 (1)
// #define _TIM2 (1)
// #define _TIM3 (1)
// #define _TIM4 (1)
// #define _IRTIM (1)

 // USART *******************************************************************
// #define _USART (1)

 // WAIT FOR EVENT  *********************************************************
// #define _WFE (1)

 // WINDOW WDG **************************************************************
// #define _WWDG (1)

// Exported macro ------------------------------------------------------------

/**
  * @brief The assert macro is used for function's parameters check.
  * It is used only if the library is compiled in DEBUG mode.
  * There is a normal mode and a full mode when the FULL_ASSERT constant is
  * defined.
  * @par Parameters:
  * expr : If expr is false, it calls the assert_failed call-back function.
  * This call-back function must be defined in your application.
  * @retval void None
  * @par Required preconditions:
  * None
  * @par Called functions:
  * None
  * @par Example:
  * Check GPIO mode parameter
  * @code
  * assert_param(IS_GPIO_MODE_OK(GPIO_Mode));
  * @endcode
  */

#define assert_param(expr) ((void)(0))

#endif /* __STM8L15x_CONF_H */

